var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var plugins;
function pk(plugin, key) {
    return key + plugin.author + " " + plugin.name;
}
function clone(dst, src) {
    if (src == undefined || typeof dst === "function")
        return dst;
    if (typeof dst === "object" && !Array.isArray(dst)) {
        for (var k in src) {
            if (k[0] != "_")
                dst[k] = clone(dst[k], src[k]);
        }
        return dst;
    }
    return src;
}
/** 添加和更新插件 */
function pluginAdd(plugin) {
    if (!plugin._build)
        pluginBuild(plugin);
    var pms;
    var _loop_1 = function (i) {
        var item = plugins[i];
        if (item.name == plugin.name && item.author == plugin.author) {
            pms = Promise.resolve();
            // 新老插件相同->不处理
            if (item != plugin) {
                if (plugin._params && item._params)
                    pms = pms.then(function () { return clone(plugin._params, item._params); });
                if (item.enable) {
                    // 老插件启动中->停止
                    pms = pms.then(function () { return pluginStop(item, true); });
                    // 新插件未启动->启动
                    if (!plugin.enable)
                        pms = pms.then(function () { return pluginStart(plugin, true); });
                }
                plugins.splice(i, 1, plugin);
            }
            return "break";
        }
    };
    for (var i = 0; i < plugins.length; i++) {
        var state_1 = _loop_1(i);
        if (state_1 === "break")
            break;
    }
    if (!pms) {
        plugins.push(plugin);
        pms = we.dbset("plugins", plugins.map(function (x) { return pk(x, ""); }));
    }
    return pms.then(function (x) {
        return we.dbset(pk(plugin, "plugin."), plugin, function (k, v) { return (k[0] == "_" ? undefined : v); });
    });
}
function pluginBuild(plugin) {
    var inject = {
        we: {},
        window: undefined,
        document: undefined,
        history: undefined,
        location: undefined,
        eval: undefined,
        Function: undefined,
        globalThis: undefined,
        cordova: undefined,
        global: undefined,
        setTimeout: function () {
            if (!plugin.enable)
                throw new Error("plugin disabled");
            if (!plugin._running)
                throw new Error("plugin stoped");
            return setTimeout.apply(null, arguments);
        },
        console: {
            log: console.log.bind(console, "plugin:" + plugin.author + "@" + plugin.name),
            error: console.error.bind(console, "plugin:" + plugin.author + "@" + plugin.name),
        },
        setInterval: undefined,
    };
    plugin._cleanups = [];
    var _loop_2 = function (key) {
        var v = we[key];
        if (~["dbget", "get", "post"].indexOf(key)) {
            inject.we[key] = function (url, data, config) {
                return v.call(we, url, data, Object.assign({ ignore: true }, config));
            };
        }
        else if (typeof v === "function")
            inject.we[key] = function () {
                if (!plugin.enable)
                    throw new Error("plugin disabled");
                if (!plugin._running)
                    throw new Error("plugin stoped");
                return v.apply(we, arguments);
            };
        else
            inject.we[key] = we.readonly(v);
    };
    for (var _i = 0, _a = plugin.grants; _i < _a.length; _i++) {
        var key = _a[_i];
        _loop_2(key);
    }
    var dbkey = pk(plugin, "data.") + " ";
    for (var _b = 0, _c = [
        "setData",
        "getData",
        "dbget",
        "dbset",
        "newFloatWindow",
        "openFloatWindow",
        "closeFloatWindow",
        "destroyFloatWindow",
        "evalFloatWindow",
    ]; _b < _c.length; _b++) {
        var key = _c[_b];
        if (inject.we[key])
            inject.we[key] = (function (fn) {
                return function () {
                    var args = Array.from(arguments);
                    args[0] = dbkey + args[0];
                    return fn.apply(inject.we, args);
                };
            })(inject.we[key]);
    }
    if (inject.we.dbkeys)
        inject.we.dbkeys = (function (fn) {
            return function () {
                return fn().then(function (x) { return x.filter(function (x) { return x.startsWith(dbkey); }); });
            };
        })(inject.we.dbkeys);
    var inject_keys = Object.keys(inject);
    var inject_values = Object.values(inject);
    var module = { exports: {} };
    new (Function.bind.apply(Function, __spreadArray(__spreadArray([void 0, "exports", "module"], inject_keys, false), [plugin.code], false)))().apply(void 0, __spreadArray([module.exports,
        module], inject_values, false));
    if (module.exports.params)
        plugin._params = clone(module.exports.params, plugin._params);
    module.exports.save = function () {
        return pluginSaveParams(plugin, plugin._params);
    };
    module.exports.setText = function (s) { };
    Object.defineProperty(module.exports, "params", {
        get: function () {
            return plugin._params;
        },
    });
    plugin.events = [];
    for (var k in module.exports) {
        var v = module.exports[k];
        if (k.startsWith("on") && typeof v === "function") {
            plugin.events.push(k.slice(2));
            plugin[k] = module.exports[k].bind(module.exports);
        }
    }
    if (typeof module.exports.run === "function") {
        plugin.run = module.exports.run.bind(module.exports);
        var win_1 = we.newFloatWindow(pk(plugin, "of."), {
            url: we.config._baseURL + "plugin.html",
            x: 0,
            y: 600,
            width: 170,
            height: 170,
            movable: true,
        });
        var text_1;
        module.exports.setText = function (s) {
            if (s) {
                win_1.open();
                text_1 = s;
                return win_1.eval("if(window.app)app.innerHTML=" + JSON.stringify(s));
            }
            return win_1.close();
        };
        var cb_1 = function () {
            return pluginRun(plugin, text_1).then(pluginsEmit, function (e) { return we.toast("执行失败:" + errInfo(e)); });
        };
        win_1.on("click", cb_1);
        plugin._cleanups.push(function () {
            we.off("click", cb_1);
            win_1.destroy();
        });
    }
    if (typeof module.exports.onTime === "function")
        plugin.onTime = module.exports.onTime.bind(module.exports);
    if (typeof module.exports.getParams === "function")
        plugin.getParams = module.exports.getParams.bind(module.exports);
    if (typeof module.exports.setParams === "function")
        plugin.setParams = module.exports.setParams.bind(module.exports);
    if (typeof module.exports.getLogs === "function")
        plugin.getLogs = module.exports.getLogs.bind(module.exports);
    plugin._build = true;
}
var runQueue = Promise.resolve(0);
function withRun(plugin, fn, immediate) {
    ++plugin._running;
    var pms = (immediate ? Promise.resolve() : runQueue).then(fn, fn).then(function (x) {
        if (--plugin._running < 0)
            plugin._running = 0;
        return x;
    }, function (e) {
        if (--plugin._running < 0)
            plugin._running = 0;
        return Promise.reject(e);
    });
    if (!immediate)
        runQueue = pms;
    return pms;
}
function pluginStart(plugin, nosave) {
    if (plugin.enable)
        return Promise.resolve();
    plugin.enable = true;
    var pms = Promise.resolve();
    if (!plugin._build)
        pms = pms.then(function () { return pluginBuild(plugin); });
    if (!nosave)
        return pms.then(function () { return pluginAdd(plugin); });
    return pms;
}
function pluginSaveParams(plugin, params) {
    if (params == null)
        return Promise.resolve();
    plugin._params = params;
    if (plugin._save_params_pms)
        return plugin._save_params_pms;
    return (plugin._save_params_pms = we
        .sleep(1e3)
        .then(function () { return we.dbset(pk(plugin, "params."), plugin._params); }));
}
function pluginRun(plugin, mode) {
    var old = plugin.enable;
    plugin.enable = true;
    return we
        .isAccessibilitySettingsOn()
        .then(function (x) { return x || Promise.reject("请先开启辅助功能"); })
        .then(function () {
        if (!plugin._build)
            pluginBuild(plugin);
        return withRun(plugin, function () { return plugin.run(mode); });
    })
        .then(function (x) {
        plugin.enable = old;
        return x;
    }, function (x) {
        plugin.enable = old;
        return Promise.reject(x);
    });
}
function pluginStop(plugin, nosave) {
    if (!plugin.enable)
        return Promise.resolve();
    for (var _i = 0, _a = plugin._cleanups; _i < _a.length; _i++) {
        var cleanup = _a[_i];
        cleanup();
    }
    plugin.enable = false;
    if (!nosave)
        return pluginAdd(plugin);
    return Promise.resolve();
}
function pluginDel(plugin) {
    var pms = pluginStop(plugin, true);
    for (var i = 0; i < plugins.length; i++) {
        var item = plugins[i];
        if (item.name == plugin.name && item.author == plugin.author) {
            plugins.splice(i, 1);
            break;
        }
    }
    return pms
        .then(function () {
        return we.dbset("plugins", plugins.map(function (x) { return x.author + " " + x.name; }));
    })
        .then(function () { return plugin._params && we.dbset(pk(plugin, "params."), null); })
        .then(function () { return we.dbset(pk(plugin, "plugin."), null); });
}
function pluginUpdate(plugin) {
    if (!plugin.updateURL)
        return Promise.resolve();
    return we
        .get(plugin.updateURL, null, { ignore: true })
        .then(function (code) {
        try {
            var item = we.pluginCompile(code);
            if (item.author == plugin.author && item.name == plugin.name) {
                if (item.version != plugin.version)
                    return pluginAdd(item);
            }
            else {
                return Promise.reject(new Error("更新脚本的作者/名称不一致"));
            }
        }
        catch (e) {
            return Promise.reject(e);
        }
    })
        .then(function (x) {
        plugin.fetchUpdateAt = Date.now();
        return x;
    }, function (e) {
        plugin.fetchUpdateAt = Date.now();
        return Promise.reject(e);
    });
}
function pluginGet(author, name) {
    for (var _i = 0, plugins_1 = plugins; _i < plugins_1.length; _i++) {
        var item = plugins_1[_i];
        if (item.author === author && item.name === name)
            return item;
    }
}
function getPluginList() {
    return we.dbget("plugins").then(function (keys) {
        if (!keys)
            return [];
        return Promise.all(keys.map(function (key) {
            return we
                .dbget(("plugin." + key))
                .then(function (plugin) {
                plugin._running = 0;
                if (!plugin._build)
                    pluginBuild(plugin);
                var pms = (plugin.getParams ? plugin.getParams() : we.dbget(("params." + key))).then(function (x) { return clone(plugin._params, x); });
                if (plugin.enable) {
                    plugin.enable = false;
                    pms = pms.then(function () { return pluginStart(plugin, true); });
                }
                return pms.then(function () { return plugin; });
            })
                .catch(function () { return null; });
        })).then(function (x) { return x.filter(function (x) { return x; }); });
    });
}
var prevOnTimeRunning;
function pluginLoop() {
    var now = Date.now();
    var plugin;
    for (var _i = 0, plugins_2 = plugins; _i < plugins_2.length; _i++) {
        var item = plugins_2[_i];
        if (now - item.fetchUpdateAt > item.updateFreq) {
            pluginUpdate(item);
        }
        if (!prevOnTimeRunning && item.enable && item.onTime && item.cronFreq) {
            if (!item._nextOnTime)
                item._nextOnTime = 0;
            if (item._nextOnTime < now && (!plugin || plugin._nextOnTime > item._nextOnTime))
                plugin = item;
        }
    }
    if (plugin) {
        prevOnTimeRunning = true;
        plugin._nextOnTime = now + plugin.cronFreq;
        withRun(plugin, function () { return plugin.onTime(); }).then(function () {
            prevOnTimeRunning = false;
        }, function (e) {
            prevOnTimeRunning = false;
            console.error(e);
        });
    }
    we.sleep(1e3).then(pluginLoop);
}
function pluginsEmit() {
    var list = plugins.map(function (item) {
        var a = Object.assign({}, item);
        a.run = !!item.run;
        if (a.getLogs)
            a.logs = a.getLogs();
        delete a.code;
        delete a._params;
        delete a._save_params_pms;
        return a;
    });
    we.emit("plugin.list\n" + JSON.stringify(list), 1);
}
getPluginList().then(function (x) {
    if (plugins) {
        for (var _i = 0, plugins_3 = plugins; _i < plugins_3.length; _i++) {
            var item = plugins_3[_i];
            pluginStop(item, true);
        }
    }
    plugins = x;
    pluginsEmit();
    pluginLoop();
    we.on("plugin.add", function (_a) {
        var data = _a.data;
        try {
            var item = we.pluginCompile(data);
            pluginAdd(item).then(pluginsEmit, function (e) { return we.toast("添加失败:" + errInfo(e)); });
        }
        catch (e) {
            we.toast("添加失败:" + errInfo(e));
        }
    });
    we.on("plugin.del", function (_a) {
        var data = _a.data;
        var plugin = pluginGet(data.author, data.name);
        if (!plugin)
            return we.toast("脚本不存在");
        pluginDel(plugin).then(pluginsEmit, function (e) { return we.toast("删除失败:" + errInfo(e)); });
    });
    we.on("plugin.start", function (_a) {
        var data = _a.data;
        var plugin = pluginGet(data.author, data.name);
        if (!plugin)
            return we.toast("脚本不存在");
        pluginStart(plugin).then(pluginsEmit, function (e) { return we.toast("启动失败:" + errInfo(e)); });
    });
    we.on("plugin.stop", function (_a) {
        var data = _a.data;
        var plugin = pluginGet(data.author, data.name);
        if (!plugin)
            return we.toast("脚本不存在");
        pluginStop(plugin).then(pluginsEmit, function (e) { return we.toast("停止失败:" + errInfo(e)); });
    });
    we.on("plugin.params", function (_a) {
        var data = _a.data;
        var plugin = pluginGet(data.author, data.name);
        if (!plugin)
            return we.toast("脚本不存在");
        (plugin.setParams
            ? Promise.resolve(plugin.setParams(data.params))
            : pluginSaveParams(plugin, data.params)).then(pluginsEmit, function (e) { return we.toast("参数设置失败:" + errInfo(e)); });
    });
    we.on("plugin.getparams", function (_a) {
        var data = _a.data;
        var plugin = pluginGet(data.author, data.name);
        if (!plugin)
            return we.toast("脚本不存在");
        if (plugin.getParams)
            plugin.getParams().then(function (x) { return we.emitData(data.cb__, x); }, function (e) { return we.toast("获取脚本参数识别:" + errInfo(e)); });
        else
            we.emitData(data.cb__, plugin._params);
    });
    we.on("plugin.run", function (_a) {
        var data = _a.data;
        var plugin = pluginGet(data.author, data.name);
        if (!plugin)
            return we.toast("脚本不存在");
        pluginRun(plugin, data.mode).then(pluginsEmit, function (e) { return we.toast("执行失败:" + errInfo(e)); });
    });
    we.on("plugin.refresh", function () {
        pluginsEmit();
    });
});
function errInfo(e) {
    if (typeof e === "string")
        return e;
    if (e instanceof Error)
        return e.message;
    return JSON.stringify(e);
}
function emit(type) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    if (!Array.isArray(plugins))
        return;
    if (!/WindowChange|ContentChange/.test(type))
        console.log("plugin emit: ", type, args);
    plugins.forEach(function (plugin) {
        if (plugin.enable && plugin["on" + type])
            withRun(plugin, function () { return plugin["on" + type].apply(plugin, args); }, true);
    });
}
function waitEmit(type) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    if (!Array.isArray(plugins))
        return Promise.resolve();
    var pms = Promise.resolve(false);
    var _loop_3 = function (plugin) {
        if (plugin.enable && plugin["on" + type])
            pms = pms.then(function (x) { return x || withRun(plugin, function () { return plugin["on" + type].apply(plugin, args); }, true); });
    };
    for (var _a = 0, plugins_4 = plugins; _a < plugins_4.length; _a++) {
        var plugin = plugins_4[_a];
        _loop_3(plugin);
    }
    return pms;
}
var prevpkg, prevcls;
var skip2048 = false;
we.on("a:32", function (evt) {
    if (!evt.data)
        return;
    var ss = evt.data.split(",");
    var pkg = ss[0];
    var cls = ss[1];
    if (prevpkg != pkg)
        emit("AppChange", pkg, prevpkg);
    emit("WindowChange", pkg, cls, prevpkg, prevcls);
    prevpkg = pkg;
    prevcls = cls;
    if (skip2048)
        return;
    skip2048 = true;
    waitEmit("ContentChange", prevpkg, prevcls)
        .catch(console.error)
        .then(function (x) { return (skip2048 = false); });
});
we.on("a:2048", function (evt) {
    if (!evt.data)
        return;
    if (skip2048)
        return;
    skip2048 = true;
    var node = evt.data;
    if (prevpkg == null)
        prevpkg = node.pkg;
    waitEmit("ContentChange", prevpkg, prevcls, node)
        .catch(console.error)
        .then(function (x) { return (skip2048 = false); });
});
we.on("a:4096", function (evt) {
    if (!evt.data)
        return;
    if (skip2048)
        return;
    skip2048 = true;
    var node = evt.data;
    if (prevpkg == null)
        prevpkg = node.pkg;
    waitEmit("ContentChange", prevpkg, prevcls, node)
        .catch(console.error)
        .then(function (x) { return (skip2048 = false); });
});
we.watchDB("setting", {
    showPoint: true,
})._pms.then(function (setting) {
    we.on("cp", function (_a) {
        var data = _a.data;
        var _b = data.split(","), x = _b[0], y = _b[1];
        if (setting.showPoint)
            we.showPoint(x, y);
    });
});
//# sourceMappingURL=plugins.js.map