var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var events = {};
var eventCache = {};
function callEvent(type, data) {
    eventCache[type] = data;
    var listens = events[type];
    if (!listens)
        return;
    listens.forEach(function (cb, i) {
        try {
            cb(data);
        }
        catch (e) {
            console.error(e);
        }
        if (cb.once)
            listens.splice(i, 1);
    });
}
var __we;
if (!__we)
    __we = { v8: 1 };
var idx = 0;
var map = {};
if (!window.getPort) {
    window.getPort = function () {
        return __we.getPort().then(function (port) { return atob(port); }, function (x) { return "0"; });
    };
}
__we.ondata = function (msg) {
    var i = msg.indexOf("\n");
    var data = {};
    if (i < 0) {
        data.type = msg;
    }
    else {
        data.type = msg.slice(0, i);
        data.data = msg.slice(i + 1);
        try {
            data.data = JSON.parse(data.data);
        }
        catch (e) { }
    }
    var ss = data.type.split(":");
    var type = ss[0];
    // if (we.config.dev) console.log("ondata:", data.type, data.data);
    callEvent(type, data);
    for (var i_1 = 1; i_1 < ss.length; i_1++) {
        type += ":" + ss[i_1];
        callEvent(type, data);
    }
};
/** 源码ID */
var sourceID = 0;
var m_watchDB = {};
var m_watchLocal = {};
var We = /** @class */ (function () {
    function We() {
        this.config = {
            _baseURL: "",
            apiURL: "https://adskip.inu1255.cn/api/",
            dev: null,
            online: false,
            jdinit: false,
            alibcInit: false,
        };
        if ("location" in window) {
            this.config._baseURL = (location.origin + location.pathname).replace(/[^\/]+$/, "");
        }
    }
    Object.defineProperty(We.prototype, "v8", {
        get: function () {
            return __we.v8;
        },
        enumerable: false,
        configurable: true
    });
    //#region event methods
    We.prototype.getEvents = function () {
        return events;
    };
    We.prototype.getEventCache = function () {
        return eventCache;
    };
    We.prototype.on = function (type, cb) {
        type = type.trim();
        if (!type)
            throw "cannot listen empty type";
        if (typeof cb === "function") {
            var listens = events[type] || (events[type] = []);
            if (listens.indexOf(cb) < 0)
                listens.push(cb);
            var c = eventCache[type];
            if (c)
                cb(c);
        }
    };
    We.prototype.once = function (type, cb) {
        type = type.trim();
        if (!type)
            return Promise.resolve();
        return new Promise(function (resolve, reject) {
            function fn(v) {
                resolve(typeof cb === "function" ? cb.apply(this, arguments) : v && v.data);
                we.off(type, fn);
            }
            (events[type] || (events[type] = [])).push(fn);
            var c = eventCache[type];
            if (c)
                fn(c);
        });
    };
    We.prototype.off = function (type, cb) {
        type = type.trim();
        var listens = events[type];
        if (!listens)
            return;
        if (!cb) {
            listens.length = 0;
            return;
        }
        var i = listens.indexOf(cb);
        if (i >= 0)
            listens.splice(i, 1);
    };
    We.prototype.offAll = function () {
        events = {};
        eventCache = {};
        return this.watchDB("config", this.config)._pms;
    };
    //#endregion
    //#region ajax methods
    We.prototype.bonjourFind = function (type) {
        return __we.bonjourFind(type);
    };
    We.prototype.bonjourStop = function () {
        return __we.bonjourStop();
    };
    We.prototype.newWS = function (url, key, ms) {
        key = key || url;
        return __we
            .newWS(url, key, ms || 0)
            .then(function (no) { return (no === "exist" ? 1 : we.once(no)); })
            .then(function () { return new WS(url, key, ms); });
    };
    We.prototype.request = function (url, method, data, headers) {
        // if (we.config.dev) console.log('request',method, url);
        return exec("request", Array.from(arguments)).then(function (s) {
            // if (/\"no[\\":]+401[\\":]/.test(s)) we.config.online = false;
            if (~s.indexOf("\"no\":401"))
                we.config.online = false;
            if (s) {
                s = JSON.parse(s);
                // if (we.config.dev) {
                // 	s.url = url;
                // 	s.method = method;
                // 	s.body = data;
                // 	s.config = headers;
                // 	console.log("request", s);
                // }
            }
            return s;
        });
    };
    We.prototype.playSound = function (url, leftVolume, rightVolume, priority, loop, rate) {
        if (leftVolume == null)
            leftVolume = 1;
        if (rightVolume == null)
            rightVolume = 1;
        if (priority == null)
            priority = 1;
        if (loop == null)
            loop = 0;
        if (rate == null)
            rate = 1;
        priority = Math.floor(priority);
        loop = Math.floor(loop);
        return __we.playSound(url, leftVolume, rightVolume, priority, loop, rate);
    };
    We.prototype.ajax = function (url, method, data, config) {
        var _this = this;
        if (url[0] == "/")
            url = this.config._baseURL + url.slice(1);
        else if (!/^\w+:\/\//.test(url))
            url = this.config.apiURL + url;
        if (data) {
            for (var k in data) {
                if (data[k] == null)
                    delete data[k];
            }
        }
        var pms = this.request(url, method, data, config)
            .then(function (x) {
            if (x.status === 404)
                return { no: 404, msg: "页面不存在" };
            if (x.status != 200)
                return { no: x.status, msg: x.data };
            try {
                return JSON.parse(x.data);
            }
            catch (error) { }
            return x.data;
        })
            .then(function (x) {
            if (x.no > 200)
                return Promise.reject(x);
            if (x.no === 200)
                return x.data;
            return x;
        });
        pms.catch(function (x) {
            console.log(url);
            if (!(config && config.ignore))
                _this.toast("\u9519\u8BEF: " + (x.msg || x));
        });
        return pms;
    };
    We.prototype.get = function (url, data, config) {
        return this.ajax(url, "get", data, config);
    };
    We.prototype.post = function (url, data, config) {
        return this.ajax(url, "post", data, config);
    };
    We.prototype.eval8 = function (url, ignore) {
        return this.get(url, null, { ignore: ignore }).then(function (x) { return we.eval(x); });
    };
    We.prototype.reportText = function (pkg, cls, text) {
        if (!text)
            return Promise.resolve();
        return we.post("page/view", { pkg: pkg, cls: cls, text: text }, { ignore: true });
    };
    //#endregion
    //#region base methods
    We.prototype.initV8 = function (restart, config) {
        var _this = this;
        Object.assign(we.config, config);
        if (chcp)
            chcp;
        return this.dbseti("v8count", 0)
            .then(function () { return __we.initV8(restart ? 1 : 0); })
            .then(function () {
            if (chcp)
                return new Promise(function (resolve, reject) {
                    chcp.getVersionInfo(function (err, x) { return (err ? reject(err) : resolve((we.ver = x))); });
                });
        })
            .then(function () { return _this.eval8("/js/we.js", true); })
            .then(function () {
            return _this.eval("Object.assign(we.config," + JSON.stringify(we.config) + ");we.ver=" + JSON.stringify(we.ver) + ";we.offAll();");
        });
    };
    We.prototype.setDebug = function (debug) {
        return __we.setDebug(debug ? 1 : 0);
    };
    /**
     * 在后台执行js代码
     */
    We.prototype.eval = function (code) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (typeof code === "function")
            code = "(" + code + ").apply(window," + JSON.stringify(args) + ")";
        var name = ++sourceID + ".js";
        return __we.eval(name, code);
    };
    /**
     * 广播消息
     * 辅助功能开启：     c
     * 辅助功能关闭：     d
     * 按键事件：        k:[keyCode]         [action]:[characters]
     * 辅助事件：        a:[eventType]       [pkg],[cls]
     * 消息事件：        n:[nid]             [data]
     * 函数回调：        cb:[random]
     * 浮窗权限申请结果： float               0/1
     * 录屏权限申请结果： screen_capture      0/1
     * 权限申请结果：     g:[权限]            0/1
     * kv写入事件：      db:[key]
     * 浮窗事件：        of:[key]:[type]     [msg]
     * @param {string} data
     * @param {number} mode 0x01 广播给前端 0x02 广播给后台
     */
    We.prototype.emit = function (data, mode) {
        if (mode === void 0) { mode = 3; }
        return __we.emit(data, mode);
    };
    We.prototype.emitData = function (type, data) {
        if (!data)
            return this.emit(type, 3);
        if (data.cb__ === true)
            data.cb__ = "cb." + type + "." + Math.floor(Math.random() * 1e4);
        var pms = this.emit(type + "\n" + JSON.stringify(data), 3);
        if (data.cb__)
            return we.once(data.cb__);
        return pms;
    };
    We.prototype.checkNetwork = function () {
        return __we.checkNetwork();
    };
    We.prototype.getIp = function () {
        return __we.getIp();
    };
    We.prototype.deviceID = function () {
        return __we.deviceID();
    };
    We.prototype.getLauncherName = function () {
        return __we.getLauncherName();
    };
    //#endregion
    //#region system methods
    /**
     * 打印日志
     * @param {string} msg
     */
    We.prototype.info = function (msg) {
        return __we.info(msg);
    };
    /**
     * 打印日志
     * @param {string} msg
     */
    We.prototype.error = function (msg) {
        return __we.error(msg);
    };
    We.prototype.sleep = function (ms) {
        return __we.sleep(Math.max(Math.floor(ms), 1));
    };
    We.prototype.getBatteryLevel = function () {
        return __we.getBatteryLevel();
    };
    We.prototype.copy = function (text, label) {
        return __we.copy(text || "", label || "");
    };
    We.prototype.paste = function () {
        var _this = this;
        return __we.paste().then(function (no) { return (/^cb:/.test(no) ? _this.once(no) : no); });
    };
    /**
     * @param {string} text
     * @param {number} duration 0: short 1: long
     */
    We.prototype.toast = function (text, duration) {
        if (!text)
            return Promise.reject("toast need argument");
        duration = duration ? 0 : 1;
        return __we.toast(text, duration);
    };
    We.prototype.xtoast = function (base64, setting) {
        return __we.xtoast(base64, setting);
    };
    We.prototype.isScreenOn = function () {
        return __we.isScreenOn ? __we.isScreenOn() : Promise.resolve(1);
    };
    We.prototype.wakeup = function (ms) {
        return __we.wakeup(ms || 0);
    };
    We.prototype.requestPermissions = function (permissions) {
        if (!permissions)
            return Promise.resolve(true);
        return __we
            .requestPermissions(permissions)
            .then(we.once)
            .then(function (map) {
            if (!map)
                return false;
            for (var k in map) {
                var v = map[k];
                if (v)
                    return false;
            }
            return true;
        });
    };
    We.prototype.open = function (pkg, cls, extra) {
        return exec("open", Array.from(arguments));
    };
    We.prototype.isInstall = function (pkg) {
        if (!pkg)
            return Promise.reject("isInstall need argument");
        return __we.isInstall(pkg);
    };
    We.prototype.setData = function (key, value, replacer) {
        return __we.setData(key, JSON.stringify(value, replacer));
    };
    We.prototype.getData = function (key, def) {
        return __we.getData(key).then(optJSON(def));
    };
    We.prototype.dbset = function (key, value, replacer) {
        if (!key)
            return Promise.reject("dbset need argument");
        return __we.dbset(key, JSON.stringify(value, replacer));
    };
    We.prototype.dbget = function (key) {
        if (!key)
            return Promise.reject("dbget need argument");
        return __we.dbget(key).then(function (text) {
            try {
                return JSON.parse(text);
            }
            catch (e) { }
            return;
        });
    };
    We.prototype.dbseti = function (key, value) {
        return __we.dbseti(key, Math.floor(value));
    };
    We.prototype.dbgeti = function (key) {
        return __we.dbgeti(key);
    };
    We.prototype.ntget = function (k) {
        var _this = this;
        return we.get("setting/get", { k: k }, { ignore: true }).catch(function (x) { return _this.dbget(k); });
    };
    We.prototype.ntset = function (k, v) {
        we.post("setting/set", { k: k, v: v }, { ignore: true });
        return this.dbset(k, v);
    };
    We.prototype.watch = function (obj, fn) {
        var _this = this;
        if (typeof obj != "object")
            return obj;
        var w = obj.__watch__ || {};
        if (!obj.__watch__)
            Object.defineProperty(obj, "__watch__", { value: w });
        var _loop_1 = function (k) {
            if (obj.__watch__[k] != null)
                return "continue";
            var v = obj[k];
            if (k[0] != "_" && typeof v != "function" && v != null) {
                w[k] = this_1.watch(v, fn);
                Object.defineProperty(obj, k, {
                    enumerable: true,
                    get: function () {
                        return w[k];
                    },
                    set: function (v) {
                        if (w[k] === v)
                            return;
                        fn.call(obj);
                        w[k] = _this.watch(v, fn);
                    },
                });
            }
        };
        var this_1 = this;
        for (var k in obj) {
            _loop_1(k);
        }
        return obj;
    };
    We.prototype.watchDB = function (key, def, ms) {
        var _this = this;
        var obj = m_watchDB[key];
        if (obj)
            Object.assign(obj, def);
        else
            obj = m_watchDB[key] = def || {};
        var h, t;
        if (!obj._fn)
            obj._fn = function () {
                if (h)
                    clearTimeout(h);
                h = setTimeout(function () {
                    t = Date.now();
                    _this.dbset(key, obj, function (k, v) { return (k[0] == "_" ? undefined : v); }).then(function (x) {
                        t = x;
                    });
                }, ms);
            };
        if (!obj._pms)
            Object.defineProperty(obj, "_pms", {
                value: this.dbget(key).then(function (x) {
                    Object.assign(obj, x);
                    _this.on("db:" + key, function (_a) {
                        var type = _a.type, data = _a.data;
                        if (t > 10 || !data)
                            return;
                        Object.assign(obj.__watch__, data);
                    });
                    return obj;
                }),
            });
        return this.watch(obj, obj._fn);
    };
    We.prototype.watchLocal = function (key, def, ms) {
        var obj = m_watchLocal[key];
        if (obj)
            return obj;
        obj = def || {};
        try {
            var text = localStorage.getItem(key);
            if (text)
                Object.assign(obj, JSON.parse(text));
        }
        catch (e) { }
        var h;
        return this.watch(obj, function () {
            if (h)
                clearTimeout(h);
            h = setTimeout(function () {
                localStorage.setItem(key, JSON.stringify(obj, function (k, v) { return (k[0] == "_" ? undefined : v); }));
            }, ms);
        });
    };
    We.prototype.dbkeys = function () {
        return __we.dbkeys().then(optJSON([]));
    };
    We.prototype.deviceInfo = function () {
        return __we.deviceInfo().then(function (text) {
            var ss = text.split("\n");
            return {
                product: ss[0],
                brand: ss[1],
                model: ss[2],
                fingerprint: ss[3],
                manufacturer: ss[4],
                host: ss[5],
                version: ss[6],
                hardware: ss[7],
            };
        });
    };
    We.prototype.autostartSetting = function () {
        return __we.autostartSetting();
    };
    We.prototype.isDebuggerConnected = function () {
        return __we.isDebuggerConnected();
    };
    We.prototype.getApk = function (pkgname) {
        return __we.getApk(pkgname);
    };
    We.prototype.getAppSign = function (pkgname, algorithm) {
        if (algorithm === void 0) { algorithm = "MD5"; }
        return __we.getAppSign(pkgname, algorithm);
    };
    We.prototype.md5 = function (s, algorithm) {
        return __we.md5(s, algorithm || "");
    };
    We.prototype.throwException = function (access) {
        return __we.throwException(access ? 1 : 0);
    };
    We.prototype.readdir = function (dir) {
        return __we.readdir(dir).then(optJSON([]));
    };
    We.prototype.statFile = function (filename) {
        return __we.statFile(filename).then(optJSON(null));
    };
    We.prototype.readFile = function (filename, encode) {
        var pms = __we.readFile(filename);
        if (encode == "utf8")
            pms = pms.then(function (x) { return atob(x); });
        return pms;
    };
    We.prototype.writeFile = function (filename, b64) {
        return __we.writeFile(filename, b64);
    };
    We.prototype.copyFile = function (src, dst) {
        return __we.copyFile(src, dst);
    };
    We.prototype.unlink = function (filename) {
        return __we.writeFile(filename, null);
    };
    We.prototype.isDeviceAdmin = function () {
        return __we.isDeviceAdmin();
    };
    We.prototype.requestDeviceAdmin = function () {
        return __we.requestDeviceAdmin();
    };
    We.prototype.uninstallNormal = function (pkgname) {
        return __we.uninstallNormal(pkgname);
    };
    We.prototype.installNormal = function (path) {
        return __we.installNormal(path);
    };
    //#endregion
    //#region accessibility methods
    We.prototype.clickXY = function (x, y, duration) {
        return __we.clickXY(Math.floor(x), Math.floor(y), duration || 1);
    };
    We.prototype.openAccessibilitySetting = function () {
        return __we.openAccessibilitySetting();
    };
    We.prototype.exit = function (code) {
        return __we.exit(code || 0);
    };
    We.prototype.restart = function (ms) {
        return __we.restart(ms || 500);
    };
    We.prototype.isAccessibilitySettingsOn = function () {
        return __we.isAccessibilitySettingsOn();
    };
    We.prototype.disableAccessibility = function () {
        return __we.disableAccessibility();
    };
    We.prototype.printTree = function () {
        return __we.printTree();
    };
    We.prototype.setIgnore = function (pkgs, clss, eventTypes) {
        return __we.setIgnore(pkgs.join(","), clss.join(","), eventTypes.join(","));
    };
    /**
     *
     * @param needText 0x01: 文字 0x02: view 0x04: 可点击 0x08: 返回坐标
     * @param subText
     * @param area
     * @returns
     */
    We.prototype.getNodes = function (needText, subText, area) {
        subText = subText || "";
        return __we
            .getNodes(+needText || 0, subText, area)
            .then(optJSON([]))
            .then(function (list) {
            return list.map(function (x) {
                if (x.m & (1 << 0))
                    x.isClickable = true;
                if (x.m & (1 << 1))
                    x.isLongClickable = true;
                if (x.m & (1 << 2))
                    x.isCheckable = true;
                if (x.m & (1 << 3))
                    x.isAccessibilityFocused = true;
                if (x.m & (1 << 4))
                    x.isChecked = true;
                if (x.m & (1 << 5))
                    x.isContentInvalid = true;
                if (x.m & (1 << 6))
                    x.isDismissable = true;
                if (x.m & (1 << 7))
                    x.isEditable = true;
                if (x.m & (1 << 8))
                    x.isEnabled = true;
                if (x.m & (1 << 9))
                    x.isFocusable = true;
                if (x.m & (1 << 10))
                    x.isFocused = true;
                if (x.m & (1 << 11))
                    x.isMultiLine = true;
                if (x.m & (1 << 12))
                    x.isPassword = true;
                if (x.m & (1 << 13))
                    x.isScrollable = true;
                if (x.m & (1 << 14))
                    x.isSelected = true;
                if (x.m & (1 << 15))
                    x.isVisibleToUser = true;
                if (x.m & (1 << 16))
                    x.isContextClickable = true;
                if (x.m & (1 << 17))
                    x.isImportantForAccessibility = true;
                if (x.m & (1 << 18))
                    x.isShowingHintText = true;
                if (x.m & (1 << 19))
                    x.isHeading = true;
                if (x.m & (1 << 20))
                    x.isScreenReaderFocusable = true;
                return x;
            });
        });
    };
    /**
     * @param {string} text
     * @param {number} [maxLen=6]
     * @returns {Promise<AccessibilityNode[]>}
     */
    We.prototype.findSubText = function (text, maxLen) {
        if (!text)
            return Promise.reject("findSubText need argument");
        return __we.findSubText(text, maxLen || 6);
    };
    We.prototype.getCurrentPackage = function () {
        return __we.getCurrentPackage();
    };
    We.prototype.getCurrentClass = function () {
        return __we.getCurrentClass();
    };
    /**
     * findAccessibilityNodeInfosByText 匹配的全部点击
     * @param {string} text
     */
    We.prototype.clickByText = function (text) {
        return __we.clickByText(text);
    };
    /**
     * findAccessibilityNodeInfosByViewId 匹配的全部点击
     * @param {string} id
     */
    We.prototype.clickByView = function (id, flag) {
        return __we.clickByView(id, +flag || 0);
    };
    /**
     * 通过 getNodes 获得的ID点击
     * @param {number} id
     * @param {number} flag 1:按坐标点击 2:按节点点击
     */
    We.prototype.clickById = function (id, flag) {
        return __we.clickById(id, +flag || 0);
    };
    We.prototype.getPathById = function (id, flag) {
        return __we.getPathById(id, +flag || 0);
    };
    We.prototype.getNodeByPath = function (path, pkg) {
        return __we.getNodeByPath(path, pkg).then(optJSON(null));
    };
    We.prototype.clickByPath = function (path, pkg, flag) {
        return __we.clickByPath(path, pkg, +flag || 0);
    };
    We.prototype.clickImage = function (src, method) {
        return __awaiter(this, void 0, void 0, function () {
            var node;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, we.matchTemplate("", src, method == null ? 1 : method)];
                    case 1:
                        node = _a.sent();
                        if (!(node.value < 0.02)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.click(node)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, true];
                    case 3: return [2 /*return*/, false];
                }
            });
        });
    };
    We.prototype.click = function (data, pkg, flag) {
        return __awaiter(this, void 0, void 0, function () {
            var node, nodes, _i, nodes_1, item, nodes, _a, nodes_2, item;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(data.dx || data.dy)) return [3 /*break*/, 6];
                        node = void 0;
                        if (!data.path) return [3 /*break*/, 2];
                        return [4 /*yield*/, we.getNodeByPath(data.path, pkg)];
                    case 1:
                        node = _b.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, we.getNodes(3)];
                    case 3:
                        nodes = _b.sent();
                        for (_i = 0, nodes_1 = nodes; _i < nodes_1.length; _i++) {
                            item = nodes_1[_i];
                            if (data.view && item.view != data.view)
                                continue;
                            if (data.text && item.text != data.text)
                                continue;
                            node = item;
                            break;
                        }
                        _b.label = 4;
                    case 4:
                        if (!node)
                            return [2 /*return*/, false];
                        return [4 /*yield*/, we.clickXY((node.left + node.right) / 2 + (data.dx || 0), (node.top + node.bottom) / 2 + (data.dy || 0))];
                    case 5: return [2 /*return*/, _b.sent()];
                    case 6:
                        if (!(data.x && data.y)) return [3 /*break*/, 8];
                        return [4 /*yield*/, we.clickXY(data.x, data.y)];
                    case 7: return [2 /*return*/, _b.sent()];
                    case 8:
                        if (!data.path) return [3 /*break*/, 10];
                        return [4 /*yield*/, we.clickByPath(data.path, pkg, flag)];
                    case 9: return [2 /*return*/, _b.sent()];
                    case 10:
                        if (!data.image) return [3 /*break*/, 12];
                        return [4 /*yield*/, we.clickImage(data.image)];
                    case 11: return [2 /*return*/, _b.sent()];
                    case 12:
                        if (!(data.view || data.text)) return [3 /*break*/, 17];
                        return [4 /*yield*/, we.getNodes(3)];
                    case 13:
                        nodes = _b.sent();
                        _a = 0, nodes_2 = nodes;
                        _b.label = 14;
                    case 14:
                        if (!(_a < nodes_2.length)) return [3 /*break*/, 17];
                        item = nodes_2[_a];
                        if (data.view && item.view != data.view)
                            return [3 /*break*/, 16];
                        if (data.text && item.text != data.text)
                            return [3 /*break*/, 16];
                        return [4 /*yield*/, we.clickById(item.id)];
                    case 15: return [2 /*return*/, _b.sent()];
                    case 16:
                        _a++;
                        return [3 /*break*/, 14];
                    case 17: return [2 /*return*/, false];
                }
            });
        });
    };
    We.prototype.setNodeText = function (id, text) {
        return __we.setNodeText(id, text);
    };
    /**
     * 包含关键词的都点击
     * @param {string} text
     * @param {number} [maxLen=6]
     */
    We.prototype.clickSubText = function (text, maxLen) {
        return __we.clickSubText(text, maxLen || 6);
    };
    /**
     * 获取所有文字
     * @returns {Promise<string>}
     */
    We.prototype.getAllText = function () {
        return __we.getAllText();
    };
    /**
     *
     * @param {number} action [null, BACK, HOME, RECENTS, ]
     * 1: go back.
     * 2: go home.
     * 3: toggle showing the overview of recent apps. Will fail on platforms that don't
     * 4: open the notifications.
     * 5: open the quick settings.
     * 6: open the power long-press dialog.
     * 7: toggle docking the current app's window
     * 8: lock the screen
     * 9: take a screenshot
     */
    We.prototype.performGlobalAction = function (action) {
        return __we.performGlobalAction(action).catch(function (x) { return 0; });
    };
    /**
     * 执行手势
     * @param {string} paths "x0,y0,x1,y1,..."
     * @param {number} startTime
     * @param {number} duration
     */
    We.prototype.dispatchGesture = function (paths, startTime, duration) {
        return __we.dispatchGesture(paths, startTime, duration);
    };
    We.prototype.swape = function (direction, duration) {
        return __awaiter(this, void 0, void 0, function () {
            var size, path;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.screenSize()];
                    case 1:
                        size = _a.sent();
                        switch (direction) {
                            case "up":
                                path = [size.x * 0.5, size.y * 0.7, size.x * 0.5, size.y * 0.3];
                                break;
                            case "down":
                                path = [size.x * 0.5, size.y * 0.3, size.x * 0.5, size.y * 0.7];
                                break;
                            case "right":
                                path = [size.x * 0.3, size.y * 0.5, size.x * 0.7, size.y * 0.5];
                                break;
                            case "left":
                                path = [size.x * 0.7, size.y * 0.5, size.x * 0.3, size.y * 0.5];
                                break;
                        }
                        if (path)
                            return [2 /*return*/, we.dispatchGesture(path.map(function (x) { return Math.floor(x); }).join(","), 0, duration || 300)];
                        return [2 /*return*/, Promise.resolve()];
                }
            });
        });
    };
    //#endregion
    //#region notify methods
    We.prototype.sendNotification = function (title, text, json) {
        return __we.sendNotification(title, text, json);
    };
    We.prototype.notificationCancel = function (id) {
        return __we.notificationCancel(id);
    };
    We.prototype.isNotificationEnabled = function () {
        return __we.isNotificationEnabled();
    };
    We.prototype.openNotificationSetting = function () {
        return __we.openNotificationSetting();
    };
    //#endregion
    //#region ui methods
    We.prototype.screenSize = function () {
        return __we.screenSize().then(function (s) {
            var ss = s.split(",");
            return { x: +ss[0], y: +ss[1], h: +ss[2], f: +ss[3] || 0, dpi: +ss[4] || 0 };
        });
    };
    We.prototype.getIPLocal = function () {
        return __we.getIPLocal().then(function (x) { return (x ? x.split(",") : []); });
    };
    /**
     * @param {number} [flag] 0:全部 1:用户 2:系统
     */
    We.prototype.getApps = function (flag) {
        flag = +flag || 0;
        return __we.getApps(flag).then(function (lines) {
            return lines
                .trim()
                .split("\n")
                .map(function (line) {
                var ss = line.split(",");
                var logo = ss.slice(5).join(",");
                if (!logo)
                    logo = "http://we/icon/" + ss[2];
                return {
                    flags: +ss[0],
                    name: ss[1],
                    pkg: ss[2],
                    version: ss[3],
                    ver: +ss[4],
                    logo: logo,
                };
            });
        });
    };
    /**
     * @param {number} flag 0x04000000 全屏
     */
    We.prototype.addFlags = function (flag) {
        return __we.addFlags(flag);
    };
    /**
     * @param {number} flag 0x04000000 全屏
     */
    We.prototype.clearFlags = function (flag) {
        return __we.clearFlags(flag);
    };
    We.prototype.setSystemUiVisibility = function (flag) {
        return __we.setSystemUiVisibility(flag);
    };
    We.prototype.setStatusBarColor = function (argb) {
        return __we.setStatusBarColor(argb);
    };
    We.prototype.canDrawOverlays = function () {
        return __we.canDrawOverlays();
    };
    We.prototype.checkFloatWindow = function () {
        return __we.checkFloatWindow();
    };
    We.prototype.applyFloatWindow = function () {
        return __we.applyFloatWindow();
    };
    We.prototype.getAllFloatWindow = function () {
        return __we.getAllFloatWindow().then(optJSON([]));
    };
    We.prototype.closeAllFloatWindow = function () {
        var _this = this;
        return this.getAllFloatWindow().then(function (fs) { return fs.forEach(function (x) { return _this.closeFloatWindow(x); }); });
    };
    We.prototype.newFloatWindow = function (key, opts) {
        var _this = this;
        var ready;
        var r = function () {
            return ready || (ready = __we.newFloatWindow(key, opts).then(_this.once));
        };
        var float = {
            r: r,
            onclose: Promise.resolve(),
            once: function (type) { return _this.once("of:" + key + ":" + type); },
            on: function (type, cb) { return _this.on("of:" + key + ":" + type, cb); },
            off: function (type, cb) {
                return _this.off("of:" + key + ":" + type, cb);
            },
            close: function (msg) { return _this.closeFloatWindow(key, msg); },
            open: function (opts) {
                return r().then(function () {
                    float.onclose = _this.openFloatWindow(key, opts);
                    return float.onclose;
                });
            },
            eval: function (code) {
                var args = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    args[_i - 1] = arguments[_i];
                }
                return r().then(function () { return _this.evalFloatWindow.apply(_this, __spreadArray([key, code], args, false)); });
            },
            destroy: function (msg) { return _this.destroyFloatWindow(key, msg); },
        };
        return float;
    };
    /** 关闭时返回 */
    We.prototype.openFloatWindow = function (key, opts) {
        return __we.openFloatWindow(key, opts).then(this.once);
    };
    /**
     * 关闭浮窗窗口并返回数据
     */
    We.prototype.closeFloatWindow = function (key, msg) {
        return __we.closeFloatWindow(key, JSON.stringify(msg === undefined ? 0 : msg));
    };
    /**
     * 销毁浮窗窗口并返回数据
     */
    We.prototype.destroyFloatWindow = function (key, msg) {
        for (var k in events) {
            if (k.startsWith("of:" + key + ":")) {
                delete events[k];
                delete eventCache[k];
            }
        }
        return __we.destroyFloatWindow(key, JSON.stringify(msg === undefined ? 0 : msg));
    };
    We.prototype.evalFloatWindow = function (key, code) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        if (typeof code === "function")
            code = "(" + code + ").apply(window," + JSON.stringify(args) + ")";
        return __we.evalFloatWindow(key, code).then(this.once);
    };
    /** 关闭时返回 */
    We.prototype.openLink = function (url, opts) {
        if (!url.startsWith("http"))
            url = "http://" + url;
        if (!opts)
            opts = {};
        return __we
            .openLink(url, opts.data == null ? "" : JSON.stringify(opts.data), opts.preload || "", opts.methods || "", typeof opts.color === "number" ? opts.color : -1)
            .then(newWebActivity);
    };
    We.prototype.webEval = function (no, code) {
        if (!no)
            throw new Error("need no");
        if (!code)
            throw new Error("need code");
        return __we.webEval(no, code);
    };
    We.prototype.getAllWebs = function () {
        return __we.getAllWebs().then(optJSON([]));
    };
    We.prototype.checkMoveTop = function () {
        return __we.checkMoveTop();
    };
    We.prototype.applyMoveTop = function () {
        return __we.applyMoveTop();
    };
    //#endregion
    //#region screen capture
    We.prototype.initScreenCapture = function () {
        return __we
            .applyVirtualDisplay()
            .then(we.once)
            .then(function (ok) { return (ok ? __we.initScreenCapture() : 0); });
    };
    We.prototype.initScreenRecord = function () {
        return __we
            .applyVirtualDisplay()
            .then(we.once)
            .then(function (ok) { return (ok ? __we.initScreenRecord() : 0); });
    };
    We.prototype.getScreenCapture = function () {
        return __we.getScreenCapture();
    };
    We.prototype.closeVirtualDisplay = function () {
        return __we.closeVirtualDisplay();
    };
    We.prototype.screenCapture = function () {
        var _this = this;
        return this.initScreenRecord()
            .then(function (ok) { return (ok ? _this.getScreenCapture() : Promise.reject("没有截屏权限")); })
            .then(function (b64) { return (_this.closeVirtualDisplay(), b64); });
    };
    We.prototype.scan = function (b64) {
        if (b64 && typeof b64 === "string")
            return __we.scan(b64.replace(/^data:[^;]+;base64,/, "")).then(optJSON({}));
        return __we.scan().then(optJSON({}));
    };
    We.prototype.opencvInit = function () {
        return __we.opencvInit();
    };
    /**
     *
     * @param src
     * @param tpl
     * @param method
            TM_SQDIFF = 0,
            TM_SQDIFF_NORMED = 1,
            TM_CCORR = 2,
            TM_CCORR_NORMED = 3,
            TM_CCOEFF = 4,
            TM_CCOEFF_NORMED = 5;
     * @returns
     */
    We.prototype.matchTemplate = function (src, tpl, method) {
        method = +method || 0;
        if (tpl)
            tpl = tpl.replace(/^data:[^;]+;base64,/, "");
        return __we
            .initScreenCapture()
            .then(function (x) { return (x ? x : Promise.reject("没有截屏权限")); })
            .then(function (x) { return __we.matchTemplate(src, tpl, method); })
            .then(function (s) {
            if (s) {
                var _a = s.split(",").map(function (x) { return +x; }), left = _a[0], top_1 = _a[1], width = _a[2], height = _a[3], value = _a[4];
                var x = left + width / 2;
                var y = top_1 + height / 2;
                return { x: x, y: y, left: left, top: top_1, width: width, height: height, value: value };
            }
        });
    };
    //#endregion
    //#region jd methods
    We.prototype.jdinit = function (appid, appsecret) {
        return __we.jdinit(appid, appsecret).then(this.once);
    };
    We.prototype.jdopen = function (url) {
        return __we.jdopen(url);
    };
    We.prototype.alibcInit = function () {
        return __we.alibcInit();
    };
    We.prototype.alibcOpen = function (url) {
        if (url.startsWith("//"))
            url = "http:" + url;
        return __we.alibcOpen(url);
    };
    //#endregion
    //#region cookie methods
    /**
     * @param url
     * @param cookie name=value
     */
    We.prototype.setCookie = function (url, cookie) {
        return __we.setCookie(url, cookie);
    };
    We.prototype.setCookies = function (url, cookies) {
        return __we.setCookies(url, cookies);
    };
    We.prototype.getCookie = function (url) {
        return __we.getCookie(url);
    };
    We.prototype.pushDebug = function (debug) {
        return __we.pushDebug(debug ? 1 : 0);
    };
    We.prototype.pushRegister = function (other) {
        return __we
            .pushRegister(other ? 1 : 0)
            .then(this.once)
            .then(function (data) {
            if (data[0] == "1")
                return data.slice(1);
            return Promise.reject(data.slice(1));
        });
    };
    //#endregion
    //#region extends methods
    /**
     * @param {boolean} [light] 状态栏亮色模式
     */
    We.prototype.setStatusBarLight = function (light) {
        return we.setSystemUiVisibility(light ? 0x2400 : 0x400);
    };
    /**
     * 沉浸式访问
     * @param {boolean} [light] 状态栏亮色模式
     */
    We.prototype.setImmersive = function (light) {
        return Promise.all([we.setStatusBarLight(light), we.addFlags(0x04000000)]);
    };
    //#endregion
    //#region plugin methods
    We.prototype.shareText = function (text, scene) {
        if (scene === void 0) { scene = "SESSION"; }
        return new Promise(function (resolve, reject) {
            Wechat.share({ text: text, scene: Wechat.Scene[scene] }, resolve, reject);
        });
    };
    We.prototype.shareLink = function (data, scene) {
        if (scene === void 0) { scene = "SESSION"; }
        return new Promise(function (resolve, reject) {
            Wechat.share({
                message: {
                    title: data.title,
                    description: data.description,
                    thumb: data.thumb,
                    media: {
                        type: Wechat.Type.WEBPAGE,
                        webpageUrl: data.url,
                    },
                },
                scene: Wechat.Scene[scene],
            }, resolve, reject);
        });
    };
    We.prototype.shareImage = function (data, scene) {
        if (scene === void 0) { scene = "SESSION"; }
        return new Promise(function (resolve, reject) {
            Wechat.share({
                message: {
                    title: data.title,
                    description: data.description,
                    thumb: data.thumb,
                    media: {
                        type: Wechat.Type.IMAGE,
                        image: data.url,
                    },
                },
                scene: Wechat.Scene[scene],
            }, resolve, reject);
        });
    };
    We.prototype.scanQR = function (opts) {
        return new Promise(function (resolve, reject) {
            cordova.plugins.barcodeScanner.scan(resolve, reject, opts);
        });
    };
    We.prototype.encodeQR = function (data, type) {
        if (type === void 0) { type = "TEXT"; }
        return new Promise(function (resolve, reject) {
            cordova.plugins.barcodeScanner.encode(cordova.plugins.barcodeScanner.Encode[type + "_TYPE"], data, resolve, reject);
        });
    };
    Object.defineProperty(We.prototype, "gpsWin", {
        //#endregion
        get: function () {
            return (this["_gpsWin"] ||
                (this["_gpsWin"] = we.newFloatWindow("gps", {
                    url: we.config._baseURL + "gps.html",
                    x: 10000,
                    y: 600,
                    width: 170,
                    height: 170,
                    movable: true,
                })));
        },
        enumerable: false,
        configurable: true
    });
    We.prototype.showPoint = function (x, y, forever) {
        if (isNaN(x) || isNaN(y))
            return console.error("showPoint " + x + " " + y + " is NaN");
        x -= 30;
        y -= 30;
        we.openFloatWindow("aim", {
            x: x,
            y: y,
            width: 60,
            height: 60,
            url: we.config._baseURL + "aim.html",
            forceLayout: true,
        });
        if (forever)
            return function () {
                we.closeFloatWindow("aim");
            };
        _closeShowPoint();
        return function () { };
    };
    //#region gps method
    We.prototype.setText = function (s) {
        if (s) {
            this.gpsWin.open();
            this.gps_text = s;
            return this.gpsWin.eval("if(window.app)app.innerHTML=" + JSON.stringify(s));
        }
        return this.gpsWin.close();
    };
    We.prototype.getCouponWord = function (data, type) {
        var query;
        if (type === "history") {
            query = {
                hid: data.id,
                check_login: we.config.online,
                coupon_share_url: data.coupon_share_url,
            };
        }
        else if (type === "material") {
            query = {
                mid: data.id,
                item_id: data.item_id,
                title: data.title,
                check_login: we.config.online,
                coupon_share_url: data.coupon_share_url,
            };
        }
        var url;
        switch (data.user_type) {
            case 3:
                url = "material/get_coupon_pdd";
                break;
            case 2:
                url = "material/get_coupon_jd";
                break;
            default:
                url = "material/get_coupon";
                break;
        }
        return this.get(url, query).then(function (x) { return x.coupon_word; }, function () { return ""; });
    };
    We.prototype.openCouponWord = function (data, coupon_word, share) {
        return __awaiter(this, void 0, void 0, function () {
            var url, msg, n, _a, n;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!coupon_word)
                            return [2 /*return*/];
                        if (!(data.user_type == 3)) return [3 /*break*/, 6];
                        return [4 /*yield*/, we.isInstall("com.xunmeng.pinduoduo")];
                    case 1:
                        if (!_b.sent()) return [3 /*break*/, 3];
                        return [4 /*yield*/, we.open("pinduoduo://com.xunmeng.pinduoduo/" + coupon_word)];
                    case 2:
                        _b.sent();
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, we.open("https://mobile.yangkeduo.com/" + coupon_word)];
                    case 4:
                        _b.sent();
                        _b.label = 5;
                    case 5:
                        we.setText("领取成功\n30分钟内付款有效\n");
                        return [2 /*return*/];
                    case 6:
                        if (!(data.user_type == 2)) return [3 /*break*/, 9];
                        // 京东
                        return [4 /*yield*/, we
                                .jdinit("94296142de18d7e9a23779edb8c677ab", "b942afe6d58b4a968bcd1cb90fbc567a")
                                .then(console.log, console.error)];
                    case 7:
                        // 京东
                        _b.sent();
                        return [4 /*yield*/, we.jdopen(coupon_word)];
                    case 8:
                        _b.sent();
                        we.setText("领取成功\n30分钟内付款有效\n");
                        return [2 /*return*/];
                    case 9:
                        if (!(data.user_type < 2)) return [3 /*break*/, 18];
                        if (!!we.config.alibcInit) return [3 /*break*/, 11];
                        return [4 /*yield*/, we.alibcInit().then(console.log, console.error)];
                    case 10:
                        _b.sent();
                        _b.label = 11;
                    case 11:
                        url = data.coupon_share_url || "https://detail.tmall.com/item.htm?id=" + data.item_id;
                        return [4 /*yield*/, we.alibcOpen(url)];
                    case 12:
                        msg = _b.sent();
                        if (!!msg) return [3 /*break*/, 18];
                        return [4 /*yield*/, we.sleep(1e3)];
                    case 13:
                        _b.sent();
                        we.setText("领取成功\n30分钟内付款有效\n");
                        if (!(data.coupon_amount > 0)) return [3 /*break*/, 17];
                        n = 5;
                        _b.label = 14;
                    case 14:
                        if (!(n-- > 0)) return [3 /*break*/, 17];
                        return [4 /*yield*/, we.sleep(1e3)];
                    case 15:
                        _b.sent();
                        return [4 /*yield*/, we.clickSubText("立即领券", 5)];
                    case 16:
                        if (_b.sent())
                            return [3 /*break*/, 17];
                        return [3 /*break*/, 14];
                    case 17: return [2 /*return*/];
                    case 18:
                        _a = coupon_word;
                        if (!_a) return [3 /*break*/, 20];
                        return [4 /*yield*/, we.copy(coupon_word)];
                    case 19:
                        _a = (_b.sent());
                        _b.label = 20;
                    case 20:
                        if (!_a) return [3 /*break*/, 29];
                        if (!share) return [3 /*break*/, 21];
                        we.toast("口令已复制");
                        we.shareText(coupon_word);
                        return [3 /*break*/, 29];
                    case 21:
                        we.toast("口令已复制, 打开淘宝APP");
                        we.open("com.taobao.taobao");
                        n = 5;
                        _b.label = 22;
                    case 22:
                        if (!(n-- > 0)) return [3 /*break*/, 25];
                        return [4 /*yield*/, we.sleep(1e3)];
                    case 23:
                        _b.sent();
                        return [4 /*yield*/, we.clickByPath("Vandroid:id/content>0>0>0>0>0>0>2>1", "com.taobao.taobao")];
                    case 24:
                        if (_b.sent()) {
                            we.setText("领取成功\n30分钟内付款有效\n");
                            return [3 /*break*/, 25];
                        }
                        return [3 /*break*/, 22];
                    case 25:
                        if (!(data.coupon_amount > 0)) return [3 /*break*/, 29];
                        n = 5;
                        _b.label = 26;
                    case 26:
                        if (!(n-- > 0)) return [3 /*break*/, 29];
                        return [4 /*yield*/, we.sleep(1e3)];
                    case 27:
                        _b.sent();
                        return [4 /*yield*/, we.clickSubText("立即领券", 5)];
                    case 28:
                        if (_b.sent())
                            return [3 /*break*/, 29];
                        return [3 /*break*/, 26];
                    case 29: return [2 /*return*/];
                }
            });
        });
    };
    We.prototype.meituan = function () {
        return __awaiter(this, void 0, void 0, function () {
            var n, nodes;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, we.open("imeituan://www.meituan.com/web?lch=cps:waimai:3:fda80be6603d8d66166cf0b5c61d215d:adskip:33:66534&url=https%3A%2F%2Fclick.meituan.com%2Ft%3Ft%3D1%26c%3D1%26p%3DOWMpZ-uzIFOVe6JyOONs3dAc7lP6u9DWmnR1PpT24IregfaV36V2K5wONpkt-WrfLMAQwm7hrngHZbRSxhslydu7ZfpAI9ssXFYICVBYRamRjJY2gem8WY9KN3QdO-CRxM7NqrToK0ZNEdYNLc4p06-cfUxwm59H1x5j9fhKihTBZA7cZTYyjrSrjGj949r4X-Hb4d8UgDlNpQSifO402c10uDK3zbMVEDMW_HAyh8-UipngS-MZUgnXQne6HHrqvwjjefjObBPb6Sehv8fg98_BjO3ofeoBzmJkCnAtt9dJORcrQz_4ZA9-la4JjCcQnDM1HLp8qG4mNx95uActMsQlWaie_nurY-Q20g8gYI3MbmKHkRsniQvDqVk_zQsXDNjYxW19NX5jDjDg5hLctRKKAWM9ccDNXJwlvzaDvqK571-47BJlBvCU5cJdfXmMTfOOaCMGzOQ-4VUiIvTx_xF4eP6PSgc8e6oJnJIEYNBGMt5MTTwSvmesMXwqQBCDxf_tw4SmbAqqFlHKTRNRf-PQfZ0xBDQ8FJl68bG6gXRIpjdcHKhP-1wcvVQOargon7ZsmuHGJBPcm94i33CsOqmI067A2ymX8Sa88sryCz0NdkQFZBod8RBV8yyfPnLYYUoV3rJpYidQpm-zzuMZCOEA155dNKVKtsXQXBE4WO-LoFQXGTt45UNX3O3UkzsMWvW3h8cV6uhPI9I0p6QlhvPCaYLQtPKmSo7GMzyRCqGt20fE7py_SU2hCnfw9chZ07W1rAuRZrZ2uSsA6jzpUw")];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, we.sleep(2e3)];
                    case 2:
                        _a.sent();
                        n = 3;
                        _a.label = 3;
                    case 3:
                        if (!n--) return [3 /*break*/, 8];
                        return [4 /*yield*/, we.getNodes(1)];
                    case 4:
                        nodes = _a.sent();
                        if (!(nodes.length > 5 && nodes[0].text == "外卖红包天天领" && nodes[2].text.length > 35)) return [3 /*break*/, 6];
                        return [4 /*yield*/, we.click(nodes[2])];
                    case 5:
                        _a.sent();
                        return [3 /*break*/, 8];
                    case 6: return [4 /*yield*/, we.sleep(1e3)];
                    case 7:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    We.prototype.pluginCompile = function (code) {
        var beg = code.indexOf("==UserScript==");
        var end = code.indexOf("==/UserScript==");
        if (beg < 0 || end < 0 || beg > end)
            return;
        var task = { code: code };
        code = code.slice(beg + 14, end);
        code = code.replace(/\n\s*\/\/ ?/g, "\n");
        var lines = code.split(/\n\s*@/);
        lines = lines.map(function (x) { return x.trim(); }).filter(function (x) { return x; });
        for (var _i = 0, lines_1 = lines; _i < lines_1.length; _i++) {
            var line = lines_1[_i];
            var m = /\w+\s*/.exec(line);
            if (m) {
                var name_1 = m[0];
                var value = line
                    .slice(name_1.length)
                    .replace(new RegExp(Array.from({ length: name_1.length + 1 })
                    .fill(" ")
                    .join(""), "g"), "")
                    .trim();
                name_1 = name_1.trim();
                var one = task[name_1];
                if (one) {
                    var ones = task[name_1 + "s"];
                    if (ones)
                        ones.push(value);
                    else
                        task[name_1 + "s"] = [one, value];
                }
                task[name_1] = value;
            }
        }
        // console.log(task)
        if (!task)
            throw "格式非法,找不到==UserScript==区域";
        if (!task.author)
            throw "缺少@author";
        if (!task.name)
            throw "缺少@name";
        for (var _a = 0, _b = ["pkg", "param", "mode"]; _a < _b.length; _a++) {
            var k = _b[_a];
            if (task[k] && !task[k + "s"])
                task[k + "s"] = [task[k]];
            delete task[k];
        }
        if (task.params) {
            task.paramList = task.params.map(function (x) {
                var param = {};
                var ss = x.split(/\s+/);
                param.placeholder = param.label = param.name = ss[0];
                param.type = "text";
                if (ss.length > 2) {
                    param.label = ss.slice(2).join(" ");
                    param.options = ss[1].split("|");
                    if (param.options.length)
                        param.type = "select";
                    else
                        delete param.options;
                }
                else if (ss.length == 2) {
                    param.label = ss[1];
                }
                var ll = param.label.split(",");
                param.label = ll[0];
                if (ll.length > 1)
                    param.placeholder = ll.slice(1).join(",");
                return param;
            });
        }
        task._params = {};
        var grants = new Set();
        task.code.replace(/\Wwe\.(\w+)/g, function (x0, k) {
            grants.add(k);
            return x0;
        });
        task.grants = Array.from(grants);
        task.fetchUpdateAt = Date.now();
        // 默认和至少间隔一小时
        if (task.cronFreq)
            task.cronFreq = parseFloat(task.cronFreq);
        if (!task.updateFreq || task.updateFreq < 3600e3)
            task.updateFreq = 3600e3;
        task._running = 0;
        task.enable = false;
        return task;
    };
    We.prototype.readonly = function (obj) {
        if (typeof obj === "object") {
            var out = {};
            var _loop_2 = function (k) {
                var v = obj[k];
                Object.defineProperty(out, k, {
                    enumerable: true,
                    get: function () {
                        return we.readonly(v);
                    },
                });
            };
            for (var k in obj) {
                _loop_2(k);
            }
            return out;
        }
        return obj;
    };
    // 工具方法，如节流
    We.prototype.throttle = function (fn, delay) {
        if (delay === void 0) { delay = 100; }
        var pass = true;
        return function () {
            var _this = this;
            if (pass) {
                pass = false;
                var args_1 = arguments;
                setTimeout(function () {
                    fn.apply(_this, args_1);
                    pass = true;
                }, delay);
            }
        };
    };
    We.prototype.debounce = function (fn, delay) {
        if (delay === void 0) { delay = 100; }
        var timer;
        return function () {
            var _this = this;
            var args = arguments;
            clearTimeout(timer);
            timer = setTimeout(function () {
                fn.apply(_this, args);
            }, delay);
        };
    };
    We.prototype.timestamp = function (t) {
        t = t == null ? new Date() : t;
        var year = t.getFullYear().toString();
        var month = (t.getMonth() + 1).toString();
        if (month.length < 2)
            month = "0" + month;
        var date = t.getDate().toString();
        if (date.length < 2)
            date = "0" + date;
        var hours = t.getHours().toString();
        if (hours.length < 2)
            hours = "0" + hours;
        var mintues = t.getMinutes().toString();
        if (mintues.length < 2)
            mintues = "0" + mintues;
        var seconds = t.getSeconds().toString();
        if (seconds.length < 2)
            seconds = "0" + seconds;
        return year + "-" + month + "-" + date + " " + hours + ":" + mintues + ":" + seconds;
    };
    return We;
}());
var WS = /** @class */ (function () {
    function WS(url, key, ms) {
        this.url = url;
        this.key = key;
        this.ms = ms;
    }
    WS.prototype.on = function (cb) {
        return we.on("ws:" + this.key, cb);
    };
    WS.prototype.once = function (cb) {
        return we.once("ws:" + this.key, cb);
    };
    WS.prototype.off = function (cb) {
        return we.off("ws:" + this.key, cb);
    };
    WS.prototype.write = function (data, base64) {
        return __we.writeWS(this.key, data, base64 ? 1 : 0);
    };
    WS.prototype.open = function () {
        return __we.newWS(this.url, this.key, this.ms);
    };
    WS.prototype.closed = function () {
        return __we.hasWS(this.key);
    };
    WS.prototype.close = function () {
        return __we.closeWS(this.key);
    };
    return WS;
}());
function exec(method, args) {
    return __we[method].apply(__we, args);
}
function optJSON(def) {
    return function (text) {
        try {
            if (text.startsWith("error:"))
                return Promise.reject(text.slice(6));
            return JSON.parse(text);
        }
        catch (e) { }
        return def;
    };
}
function newWebActivity(no) {
    var listens = [];
    return {
        onclose: we.once(no).then(function (x) {
            while (listens.length) {
                var a = listens.pop();
                we.off(a.type, a.cb);
            }
            return x;
        }),
        eval: function (code) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            if (typeof code === "function")
                code = "(" + code + ").apply(window," + JSON.stringify(args) + ")";
            return we.webEval(no, code);
        },
        on: function (type, cb) {
            type = "wa:" + no.slice(11).trim() + (type ? ":" + type : "");
            listens.push({ type: type, cb: cb });
            return we.on(type, cb);
        },
        once: function (type, cb) {
            type = "wa:" + no.slice(11).trim() + (type ? ":" + type : "");
            return we.once(type, cb);
        },
    };
}
var we = new We();
window["we"] = we;
//#endregion
var _closeShowPoint = we.debounce(function () {
    we.destroyFloatWindow("aim");
}, 1e3);
//# sourceMappingURL=we.js.map